c-------------------------------------------------------------------------------
c
c                            PROGRAM  MAIN                 
c
c--NOTE: change the mesh file path (filen) appropriately before running
c-------------------------------------------------------------------------------
c
      program main 
c      implicit none
c
c-------------------------------
#include "common.F"
c-------------------------------
c
      integer ntotnodes,nonode,noedge,nobnode,nobface
      integer lesched,lfsched,lfsched2
c
      common/node/ ntotnodes,nonode,noedge,nobnode,nobface
      common/sched/ lesched,lfsched,lfsched2
c
      common/prm/ ncyc,nprnt,iplot,istart,icyc
c
      integer end_pts(medge,2)
      integer nbf(mbface,4),iloc(mnode)
      integer myvals(mnode),icheck_mem, numnodes
      real*8  w(mnode,5),p(mnode)
      real*8  volume(mnode),flux(mnode)
      integer  myedges(medge), myfaces(mbface), tedge, tbface, tbnode, itable
      integer i, k, icheck, ncyc, nprocs, icyc, mynode
      DOUBLE PRECISION dclock, st_clock, end_clock

c
c Work Space
c
      integer work(2*nge)
c
c
      character *80 filen,title, infile
      character *1 a,b
c
c--Open the output files for each of the processors
c
c      filen = '/ump/ipsc/home/icase/ravi/sc92/demo4/m6.545.part'
c      filen = '/ump/ipsc/home/icase/ravi/sc92/demo4/m6.2k.part'
c      filen = '/ump/ipsc/home/icase/ravi/sc92/demo4/m6.10k.part'
       i = SUFFIX + 48
       a = char(i)
      filen = 'data/mesh.'//a

      do 875 i = 1,80
        a = filen(i:i)
        if(a .eq. ' ') go to 876
 875   continue
 876   k = i -1
c
c--Read in pertinent data

c      call readmesh(mnode,medge,mbface,
c     .                  myvals, myedges, myfaces,
c     .                  nonode, noedge, nobface,
c     .                  ntotnodes,tedge,tbface,nobnode,end_pts,
c     .                  volume,nbf,
c     .                  len, filen)

      call dopart(myvals, ntotnodes,
     .      nonode, noedge, nobface, nobnode,
     .      end_pts,nbf,volume,
     .      work(1), work(nge+1),work(1), work(nge+1), k,filen)

c
c Initialize arrays w, p, and volume
c
        call init(mnode,nonode,w,p,volume,myvals)

        if (mynode() .eq. 0) print *, 'Pre-processing loops ...'
c
c Compute schedules
c
       call table(mnode, myvals)
       call setup(medge,mbface,end_pts,nbf, work(1), work(nge+1))
c
      ncyc = 5
      if (mynode() .eq. 0) print *, 'Executing loops ...'

      call dgather(volume(nonode+1),volume(1),lesched)
      do 100 icyc=1,ncyc
         call loops(medge,mnode,mbface,end_pts,nbf,
     .          w,p,flux,volume)
  100 continue

c
  910 continue
      stop
      end
