/*-------------------------------------------------------------------
 * This file is written by Tseng-Hui Lin. If you have any question,
 * please send e-mail to:
 *     thlin@top.cis.syr.edu  or  thlin@nova.npac.syr.edu
 *
 * Last modify : 4/14/1993
 *-------------------------------------------------------------------
 */

/*
 * This file is machine dependent. For CM5 only
 */

#include "../SYRCOMM/comm_int.h"
#include "comm_md.h"

/*
 * This is the initial program of machine dependent part.
 */

void SYR_machine_init()
{
    SYR_dbg_enter("SYR_machine_init");
    /* Nothing special for CM5 */
    SYR_dbg_exit();
}

/*
 * The message path on CM5 can not be controlled by user. We do not
 * support this function .
 */

void SYR_cschedule_RS_NLP(len_tab, mark, num_stages)
int **len_tab;
SYR_comm_stage **mark;
int *num_stages;
{
    SYR_dbg_enter("SYR_cschedule_RS_NLP");
    SYR_panic("Function SYR_cschedule_RS_NLP is not supported on CM5");
    SYR_dbg_exit();
}

/*
 * The message path on CM5 can not be controlled by user. We do not
 * support this function .
 */

void SYR_cschedule_NLP(len_tab, mark, num_stages)
int **len_tab;
SYR_comm_stage **mark;
int *num_stages;
{
    SYR_dbg_enter("SYR_cschedule_NLP");
    SYR_panic("Function SYR_cschedule_NLP is not supported on CM5");
    SYR_dbg_exit();
}

