#include <stdio.h>
#include "parti.h"
#include "parti_more.h"

trace_enter(s)
char *s;
{
  trace_cntrl(1,s,1,1);
}

trace_exit()
{
  trace_cntrl(2,NULL,1,1);
}

trace_cntrl(cmd,s,print_flag,sync_flag)
int cmd,print_flag,sync_flag;
char *s;
{
  static int level = 0;
  static int place[100];
  static char names[1000];
  int i;

  if(sync_flag) gsync();
  place[0] = 0;
  switch(cmd) {
    case 1 : 
      strcpy(&names[place[level]],s);
      place[level+1] = place[level] + strlen(s)+1;
      if(print_flag & (mynode()==0)) {
        for(i=0;i<level;i++){
          fprintf(stderr,"  ");
         }
         fprintf(stderr,"entering %s\n",&names[place[level]]);
      }
      level++;
      break;
    case 2 :
      level--;
      if(print_flag & (mynode()==0)) {
        for(i=0;i<level;i++){ 
          fprintf(stderr,"  "); 
         }
         fprintf(stderr,"exiting %s\n",&names[place[level]]);
      }
      break;
  }
}

#undef malloc()

int debug_malloc(n)
{
  char *ptr;
  int i;

  if (n <= 0) n = 1;
  ptr = (char *) malloc(n);
  if(ptr==NULL){
    fprintf(stderr,"Error, cannot allocate memory on node %d!!\n",mynode());
    exit();
  }
  for(i=0;i<n;i++){
    ptr[i] = 0;
  }
  return((int)ptr);
}
