c-------------------------------------------------------------------------------
c
c                            PROGRAM  MAIN                 
c
c-------------------------------------------------------------------------------
c
      program main 
c      implicit none
c
c-------------------------------
#include "common.F"
c-------------------------------
c
      integer ntotnodes,nonode,noedge,nobnode,nobface
      integer lesched,lfsched,lfsched2
c
      common/node/ ntotnodes,nonode,noedge,nobnode,nobface
      common/sched/ lesched,lfsched,lfsched2
c
      common/prm/ ncyc,nprnt,iplot,istart,icyc
c
      integer end_pts(medge,2)
      integer bf_pts(mbface,4),iloc(mnode)
      integer myvals(mnode),icheck_mem, numnodes
      real*8  w(mnode,5),p(mnode)
      real*8  volume(mnode),flux(mnode)
      integer  myedges(medge), myfaces(mbface), tedge, tbface, tbnode, itable
      integer ifbuild_translation_table
      integer i, k, icheck, ncyc, nprocs, icyc, mynode
      DOUBLE PRECISION dclock, st_clock, end_clock

c
c Work Space
c
      integer work(2*nge)
c
c
      character *80 filen,title, infile
      character *1 a,b
c
c--Open the output files for each of the processors
c
c      filen = '/ump/ipsc/home/icase/ravi/sc92/demo4/m6.2k.part'
c      filen = '/cfs/home/icase/ravi/mesh/m6.g2.part'
c      filen = '/cfs/home/icase/ravi/mesh/m6.c8.part'
c      filen = '/cfs/ravi/mesh/m6.g2.part'

       i = SUFFIX + 48
       a = char(i)
       filen='data/mesh.'//a
c
c--Read in pertinent data

      call readmesh(mnode,medge,mbface,
     .                  myvals, myedges, myfaces,
     .                  nonode, noedge, nobface,
     .                  ntotnodes,tedge,tbface,nobnode,end_pts,
     .                  volume,bf_pts,
     .                  len, filen)

c
c Initialize arrays w, p, and volume
c
        call init(mnode,nonode,w,p,volume,myvals)

        if (mynode() .eq. 0) print *, 'Pre-processing loops ...'
c
c Compute schedules
c
       call setup(medge,mbface,end_pts,bf_pts, work(1), work(nge+1))
c
      ncyc = 5
      if (mynode() .eq. 0) print *, 'Executing loops ...'

      call dgather(volume(nonode+1),volume(1),lesched)
      do 100 icyc=1,ncyc
         call loops(medge,mnode,mbface,end_pts,bf_pts,
     .          w,p,flux,volume)
  100 continue

c
  910 continue
      stop
      end
