#include <stdio.h>
typedef struct cell  CELLPTR;

struct cell{
    CELLPTR *nextcell;
    int     index;
    };

typedef struct hashcell  HASHPTR;

struct hashcell{
    int     node_num;
    int     tag;
    int     local;
    HASHPTR *next;
    CELLPTR *slot_num;
    };

typedef struct memlist_t MEMPTR;

static struct memlist_t{
       char *address;
       MEMPTR *next;
    };
static char *ptr;
static char *cur_ptr;
static struct memlist_t *memlist;
static struct memlist_t *cur_list;
static rem_size;

void
myalloc_init(size)
int size;
{
 int max_size;
 max_size = 3*sizeof(struct hashcell)*size;
/*
 ptr  = (char *) malloc(max_size);
 if (!ptr) printf("Not enough memory: hashtable \n");
*/
 max_size /= 2;
 ptr  = (char *) malloc(max_size);
 if (!ptr) printf("Not enough memory for  hashtable [%d]\n", mynode());
 max_size /= 4;
 ptr  = (char *) malloc(max_size);
 rem_size = max_size;
 cur_ptr  = ptr;
 memlist = (struct memlist_t *) malloc(sizeof(struct memlist_t));
 cur_list = memlist;
 memlist->next = NULL;
 memlist->address = NULL;
}

char *
mymalloc(cur_size)
int cur_size;
{
  char * ret_ptr;
  char *new_mem;

  if((rem_size-cur_size) < 0) {
    new_mem = (char *) malloc(cur_size);
    cur_list->address = (char *)new_mem;
    cur_list->next = (struct memlist_t *) malloc(sizeof(struct memlist_t));
    cur_list = cur_list->next;
    cur_list->next = NULL;
    return (char *) new_mem;
  }
  else {
    ret_ptr = cur_ptr;
    cur_ptr += cur_size;
    rem_size -= cur_size;
    return ret_ptr;
  }
}

myfree()
{
  struct memlist_t *temp;

  free(ptr);
  while (memlist->next != NULL) {
    temp = memlist->next;
    free(memlist);
    memlist = temp;
  }
}
